%define	migtools_version	45
%define	db_version		4.3.27
%define	ldbm_backend		berkeley
%define	nss_ldap_build		0
%define	nss_ldap_prefix		%{_libdir}/nss_ldap-openldap
%define	nss_ldap_includedir	%{nss_ldap_prefix}/include
%define	nss_ldap_libdir		%{nss_ldap_prefix}/%{_lib}
%define	nptl_arches		%{ix86} ia64 ppc ppc64 s390 s390x sparcv9 x86_64

Summary:	The configuration files, libraries, and documentation for OpenLDAP.
Group:		System Environment/Daemons
Name:		openldap
Version:	2.2.23
Release:	2
License:	OpenLDAP
Source0:	ftp://ftp.OpenLDAP.org/pub/OpenLDAP/openldap-release/%{name}-%{version}.tgz
Source3:	ftp://ftp.OpenLDAP.org/pub/tools/autoconf-2.13.1.tar.gz
Source4:	ftp://ftp.OpenLDAP.org/pub/tools/automake-1.4a.tar.gz
Source5:	http://downloads.sleepycat.com/db-%{db_version}.tar.gz
Source7:	ldap.init-gd-1
Source8:	ftp://ftp.padl.com/pub/MigrationTools-%{migtools_version}.tar.gz
Source9:	migration-tools.txt
Source10:	autofs.schema
Source11:	README.upgrading
Source12:	http://www.OpenLDAP.org/doc/admin/guide.html
Source13:	nptl-abi-note.S
Source15:	README.nss_ldap
Patch00:	openldap-2.2.15-config.patch
Patch01:	openldap-1.2.11-cldap.patch
Patch02:	openldap-2.0.11-ldaprc.patch
Patch03:	openldap-2.2.13-setugid.patch
Patch04:	openldap-2.2.13-pie.patch
Patch05:	openldap-2.2.15-toollinks.patch
Patch06:	openldap-2.2.13-nosql.patch
Patch07:	openldap-2.2.23-resolv.patch
Patch10:	openldap-2.2.23-start_tls-async.patch
Patch20:	MigrationTools-38-instdir.patch
Patch21:	MigrationTools-36-mktemp.patch
Patch22:	MigrationTools-27-simple.patch
Patch23:	MigrationTools-26-suffix.patch
Patch24:	MigrationTools-44-schema.patch
Patch25:	MigrationTools-45-noaliases.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildPreReq:	gdbm-devel, libtool >= 1.5.6-2
BuildPreReq:	openssl-devel, pam-devel, perl, pkgconfig, libwrap-devel
Requires:	glibc >= 2.3.5-1, mktemp

%description
OpenLDAP is an open source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. The openldap package contains configuration files,
libraries, and documentation for OpenLDAP.

%files
  %defattr(0444,root,root,0555)
  %doc openldap-%{version}/ANNOUNCEMENT
  %doc openldap-%{version}/CHANGES
  %doc openldap-%{version}/COPYRIGHT
  %doc openldap-%{version}/LICENSE
  %doc openldap-%{version}/README
  %doc %{_mandir}/man5/ldif.5*
  %doc %{_mandir}/man5/ldap.conf.5*

  %attr(0750,root,admin)	%dir %{_sysconfdir}/openldap
  %attr(0640,root,admin)	%config(noreplace) %{_sysconfdir}/openldap/ldap*.conf
  %attr(0700,root,root)		%dir %{_sysconfdir}/openldap/cacerts
  %attr(0750,root,admin)	%dir %{_datadir}/openldap

  %attr(0555,root,root)		%{_libdir}/liblber-*.so.*
  %attr(0555,root,root)		%{_libdir}/libldap-*.so.*
  %attr(0555,root,root)		%{_libdir}/libldap_r-*.so.*

%package devel
Summary:	OpenLDAP development libraries and header files.
Group:		Development/Libraries
Requires:	openldap = %{version}-%{release}

%description devel
The openldap-devel package includes the development libraries and
header files needed for compiling applications that use LDAP
(Lightweight Directory Access Protocol) internals. LDAP is a set of
protocols for enabling directory services over the Internet. Install
this package only if you plan to develop or will need to compile
customized LDAP clients.

%files devel
  %defattr(0444,root,root,0555)
  %doc openldap-%{version}/doc/drafts openldap-%{version}/doc/rfc
  %doc %{_mandir}/man3/*

  %attr(0444,root,root)		%{_includedir}/*
  %attr(0555,root,root)		%{_libdir}/libl*.so
  %attr(0544,root,root)		%{_libdir}/libl*.a

%if %{nss_ldap_build}
  %attr(0555,root,root) %dir %{nss_ldap_prefix}
  %attr(0444,root,root)      %{nss_ldap_prefix}/README*
  %attr(0555,root,root) %dir %{nss_ldap_includedir}
  %attr(0444,root,root)      %{nss_ldap_includedir}/*.h
  %attr(0555,root,root) %dir %{nss_ldap_libdir}
  %attr(0444,root,root)      %{nss_ldap_libdir}/*.a
%endif

%package servers
Summary:	OpenLDAP servers and related files.
Group:		System Environment/Daemons
Prereq:		fileutils, make, openldap = %{version}-%{release}, openssl
Prereq:		/usr/sbin/useradd, /sbin/chkconfig, /sbin/runuser

%description servers
OpenLDAP is an open-source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. This package contains the slapd and slurpd servers,
migration scripts, and related files.

%files servers
  %defattr(0444,root,root,0555)
  %doc README.migration
  %doc TOOLS.migration
  %doc %{_mandir}/man5/slapd*.5*
  %doc %{_mandir}/man8/*

  %attr(0700,root,root)		%config %{_sysconfdir}/init.d/ldap
  %attr(0640,root,ldap)		%config(noreplace) %{_sysconfdir}/openldap/slapd.conf

  %attr(0550,root,admin)	%dir %{_sysconfdir}/openldap/schema
  %attr(0640,root,admin)	%{_sysconfdir}/openldap/schema/README*
  %attr(0640,root,admin)	%config(noreplace) %{_sysconfdir}/openldap/schema/*.schema*
  %attr(0750,root,admin)	%dir %{_sysconfdir}/openldap/schema/redhat
  %attr(0640,root,admin)	%config(noreplace) %{_sysconfdir}/openldap/schema/redhat/*.schema*
  %attr(0550,root,admin)	%{_sbindir}/sl*
  %attr(0750,root,admin)	%dir %{_datadir}/openldap/migration
  %attr(0444,root,admin)	%{_datadir}/openldap/migration/README
  %attr(0640,root,admin)	%config(noreplace) %{_datadir}/openldap/migration/*.ph
  %attr(0550,root,admin)	%{_datadir}/openldap/migration/*.pl
  %attr(0550,root,admin)	%{_datadir}/openldap/migration/*.sh
  %attr(0440,root,admin)	%{_datadir}/openldap/migration/*.txt
  %attr(0750,root,admin)	%dir %{_datadir}/openldap/ucdata
  %attr(0040,root,admin)	%{_datadir}/openldap/ucdata/*

  %attr(0700,ldap,ldap)		%dir /var/lib/ldap
  %attr(0555,root,root)		%{_libdir}/libslapd_db-*.*.so

%ifarch %{nptl_arches}
%ifnarch %{ix86}
  %attr(0555,root,root) %{_libdir}/tls/libslapd_db-*.*.so
%else
# %dir %attr(0755,root,root) %{_libdir}/tls/*
  %attr(0555,root,root) %{_libdir}/tls/*/libslapd_db-*.*.so
%endif
%endif

%package clients
Summary:	Client programs for OpenLDAP.
Prereq:		openldap = %{version}-%{release}
Group:		Applications/Internet

%description clients
OpenLDAP is an open-source suite of LDAP (Lightweight Directory Access
Protocol) applications and development tools. LDAP is a set of
protocols for accessing directory services (usually phone book style
information, but other information is possible) over the Internet,
similar to the way DNS (Domain Name System) information is propagated
over the Internet. The openldap-clients package contains the client
programs needed for accessing and modifying OpenLDAP directories.

%files clients
  %defattr(0444,root,root,0555)
  %doc %{_mandir}/man1/*

  %attr(0555,root,root)		%{_bindir}/*

%prep
%setup -q -c -a 3 -a 4 -a 5 -a 8

  pushd openldap-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
    cp %{_datadir}/libtool/config.{sub,guess} build/
  popd

  # Set up a build tree for a static version of libldap with async start_tls
  # support, which nss_ldap can use to avoid blocking if a server is accepting
  # connections but is otherwise unresponsive.
%if %{nss_ldap_build}
  if ! cp -al openldap-%{version} nss_ldap-openldap-%{version} ; then
    rm -fr nss_ldap-openldap-%{version}
    cp -a  openldap-%{version} nss_ldap-openldap-%{version}
  fi

  pushd nss_ldap-openldap-%{version}
%patch10 -p0
  popd
%endif

  pushd MigrationTools-%{migtools_version}
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
  popd

  autodir=`pwd`/auto-instroot
  pushd autoconf-2.13.1
    ./configure --prefix=$autodir
    make all install
  popd

  pushd automake-1.4a
    ./configure --prefix=$autodir
    make all install
  popd

  pushd openldap-%{version}
    for subdir in build-servers build-clients ; do
	mkdir $subdir
	ln -s ../configure $subdir
    done

    $autodir/bin/autoconf
  popd

  # Remove patch fodder.
  find . -name "*.orig" -exec rm -fv {} \;

%build
  autodir=`pwd`/auto-instroot
  dbdir=`pwd`/db-instroot
  dbdir40=`pwd`/db-instroot-4.0
  libtool='%{_bindir}/libtool'
  export tagname=CC

  PATH=${autodir}/bin:${PATH}

%ifarch ia64
  RPM_OPT_FLAGS="$RPM_OPT_FLAGS -O0"
%endif

  # Set CFLAGS to incorporate RPM_OPT_FLAGS.
  export CFLAGS="$RPM_OPT_FLAGS -D_REENTRANT -fPIC"

  # Build Berkeley DB and install it into a temporary area, isolating OpenLDAP
  # from any future changes to the system-wide Berkeley DB library.  Version 4.2
  # or later is required by the BDB backend in OpenLDAP 2.1 and later.
  buildbdb() {
	subdir=$1
	shift
	install -d db-%{db_version}/build-rpm${subdir:+-${subdir}}
	pushd db-%{db_version}/build-rpm${subdir:+-${subdir}}
	echo "${1:+db_cv_mutex=$1}" > config.cache
	shift
	../dist/configure -C \
		--with-pic \
		--disable-static \
		--enable-shared \
		--with-uniquename=_openldap_slapd_rhl_42 \
		--prefix=${dbdir} \
		--includedir=${dbdir}/include \
		--libdir=${dbdir}/%{_lib}${subdir:+/${subdir}}
	# XXX db-4.2.x handles O_DIRECT (by disabling on linux) correctly.
	# XXX hack out O_DIRECT support in db4 for now.
	perl -pi -e 's/#define HAVE_O_DIRECT 1/#undef HAVE_O_DIRECT/' db_config.h
	# fix libtool: no rpath
        perl -pi -e 's|hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=\"-L\\\$libdir\"|g;' libtool

	if test -n "$nptl_lo" ; then
		./libtool --mode=compile %{__cc} -o $nptl_lo -c $nptl_s
	fi
	make %{_smp_mflags} libdb_base=libslapd_db libso_base=libslapd_db LIBSO_LIBS="$nptl_lo"
	make install libdb_base=libslapd_db libso_base=libslapd_db LIBSO_LIBS="$nptl_lo"
	ln -sf libslapd_db.so ${dbdir}/%{_lib}/${subdir}/libdb.so
	popd
  }

  # Build an NPTL libdb if we're on a Linux arch with NPTL.  NPTL gives us the
  # ability to share mutexes between threads in different processes, and to have
  # threads in both honor those locks.  We have to do this because if you build
  # libdb with support for intra-process locks, it dies if you don't have it and
  # the application has specified to libdb that it's multi-threaded (as slapd
  # does).
%ifarch %{nptl_arches}
  unset nptl_s nptl_lo
  case %{_os} in
  linux|Linux)
	nptl_s=%{SOURCE13}
	nptl_lo=nptl-abi-note.lo
	;;
  esac
  buildbdb tls POSIX/pthreads/library
  unset nptl_s nptl_lo
%endif

  # Build a non-NPTL libdb and tools, able to only use intra-process thread
  # locks.  Useless for bdb's purposes (bdb requires shared env support), but
  # acceptable for ldbm.
  buildbdb "" POSIX/pthreads/library/private

  # Find OpenSSL's header and library dependencies.
  if pkg-config openssl ; then
    OPENSSL_CPPFLAGS=`pkg-config --cflags-only-I openssl`
    CPPFLAGS="$OPENSSL_CPPFLAGS" ; export CPPFLAGS
    OPENSSL_LDFLAGS=`pkg-config --libs-only-L openssl`
    LDFLAGS="$OPENSSL_LDFLAGS" ; export LDFLAGS
  fi

  export CPPFLAGS="-I${dbdir}/include $OPENSSL_CPPFLAGS"
  export CFLAGS="$CPPFLAGS $RPM_OPT_FLAGS -D_REENTRANT -fPIC"
  export LDFLAGS="-L${dbdir}/%{_lib} $OPENSSL_LDFLAGS"
  export LD_LIBRARY_PATH=${dbdir}/%{_lib}${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}

  # Build
  build() {
    %configure \
	--disable-slapd --disable-slurpd \
	--with-threads=posix --enable-static --enable-shared --enable-dynamic \
	\
	--enable-local --enable-rlookups \
	\
	--with-tls \
	--enable-wrappers \
	\
	--enable-passwd \
	\
	--enable-cleartext \
	--enable-crypt \
	--disable-spasswd \
	--enable-modules \
	--disable-sql \
	\
	--libexecdir=%{_sbindir} \
	$@
    make %{_smp_mflags} LIBTOOL="$libtool"
  }

  # Build the servers with Kerberos support (for password checking, mainly).
  export LIBS=-lpthread
  export LD_LIBRARY_PATH=${dbdir}/%{_lib}${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
  pushd openldap-%{version}/build-servers
    build \
	--enable-plugins \
	--enable-slapd \
	--enable-slurpd \
	--enable-bdb \
	--enable-hdb \
	--enable-ldap \
	--enable-ldbm \
	--with-ldbm-api=%{ldbm_backend} \
	--enable-meta \
	--enable-monitor \
	--enable-null \
	--enable-shell \
	--disable-sql \
	--disable-perl \
	--disable-shared \
	--disable-dynamic \
	--with-kerberos=k5only
    unset LIBS
  popd

  # Build clients without Kerberos password-checking support, which is only
  # useful in the server anyway, to avoid stray dependencies.
  pushd openldap-%{version}/build-clients
    build \
	--disable-slapd \
	--disable-slurpd \
	--enable-shared \
	--enable-dynamic \
	--enable-static \
	--without-kerberos \
	--with-pic
  popd

%if %{nss_ldap_build}
  # Build nss_ldap-specific clients just as we would normal clients, except with
  # a different installation directory in mind and no shared libraries.
  pushd nss_ldap-openldap-%{version}
    build \
	--disable-slapd \
	--disable-slurpd \
	--disable-shared \
	--disable-dynamic \
	--enable-static \
	--without-kerberos \
	--with-pic \
	--includedir=%{nss_ldap_includedir} \
	--libdir=%{nss_ldap_libdir}
  popd
%endif

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  libtool='%{_bindir}/libtool'
  export tagname=CC

  install -d $RPM_BUILD_ROOT/%{_libdir}/

# Install servers.
%ifarch %{nptl_arches}
  case %{_target_platform} in
	i386*|i486*) archp=i486; arches="i586 i686";;
	i586*) archp=i586; arches=i686;;
	i686*) archp=i686; arches=;;
	athlon*) archp=i686; arches=;;
	*) archp=; arches=;;
  esac

  pushd db-instroot/%{_lib}/tls/
    install -d $RPM_BUILD_ROOT/%{_libdir}/tls/${archp}/
    install libslapd_db-*.*.so $RPM_BUILD_ROOT/%{_libdir}/tls/${archp}/

    for arch in $arches ; do
	install -d $RPM_BUILD_ROOT/%{_libdir}/tls/${arch}/
	ln $RPM_BUILD_ROOT/%{_libdir}/tls/${archp}/* $RPM_BUILD_ROOT/%{_libdir}/tls/${arch}/
    done
  popd
%endif

  pushd db-instroot/%{_lib}/
    install -d $RPM_BUILD_ROOT/%{_libdir}/
    install libslapd_db-*.*.so $RPM_BUILD_ROOT/%{_libdir}/
  popd

  pushd openldap-%{version}/build-servers
    make install DESTDIR=$RPM_BUILD_ROOT libdir=%{_libdir} LIBTOOL="$libtool"
  popd

  # Install the bdb maintenance tools.
  pushd db-instroot/bin
    for binary in db_* ; do
	install ${binary} $RPM_BUILD_ROOT/%{_sbindir}/slapd_${binary}
    done
  popd

# Install clients and shared libraries.
%if %{nss_ldap_build}
  pushd nss_ldap-openldap-%{version}
    make install DESTDIR=$RPM_BUILD_ROOT \
	includedir=%{nss_ldap_includedir} \
	libdir=%{nss_ldap_libdir} \
	LIBTOOL="$libtool"

    install %{SOURCE15} $RPM_BUILD_ROOT/%{nss_ldap_prefix}/
  popd
%endif
  pushd openldap-%{version}/build-clients
    make install DESTDIR=$RPM_BUILD_ROOT libdir=%{_libdir} LIBTOOL="$libtool"
  popd

  # Create this directory so that authconfig setting TLS_CACERT to
  # /etc/openldap/cacerts doesn't cause TLS startup of any kind to fail
  # when the directory doesn't exist.
  install -d $RPM_BUILD_ROOT%{_sysconfdir}/openldap/cacerts

  # Install the padl.com migration tools.
  install -d $RPM_BUILD_ROOT%{_datadir}/openldap/migration
  install MigrationTools-%{migtools_version}/migrate_* \
	$RPM_BUILD_ROOT%{_datadir}/openldap/migration/
  install MigrationTools-%{migtools_version}/README \
	%{SOURCE9} \
	$RPM_BUILD_ROOT%{_datadir}/openldap/migration/
  cp MigrationTools-%{migtools_version}/README README.migration
  cp %{SOURCE9} TOOLS.migration

  # Create the data directory.
  install -d $RPM_BUILD_ROOT/var/lib/ldap

  # Hack the build root out of the default config files.
  perl -pi -e "s|$RPM_BUILD_ROOT||g" $RPM_BUILD_ROOT/%{_sysconfdir}/openldap/*.conf

  # Get the buildroot out of the man pages.
  perl -pi -e "s|$RPM_BUILD_ROOT||g" $RPM_BUILD_ROOT%{_mandir}/*/*.*

  # We don't need the default files -- RPM handles changes.
  rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/openldap/*.default
  rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/openldap/schema/*.default

  # Install an init script for the servers.
  install -d $RPM_BUILD_ROOT/%{_sysconfdir}/init.d
  install %{SOURCE7} $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/ldap

  # If ldapadd and ldapmodify are the same binary, make them a hard link
  if cmp $RPM_BUILD_ROOT%{_bindir}/ldapadd $RPM_BUILD_ROOT%{_bindir}/ldapmodify ; then
    ln -f $RPM_BUILD_ROOT%{_bindir}/ldapadd $RPM_BUILD_ROOT%{_bindir}/ldapmodify
  fi

  # Add some more schema for the sake of migration scripts.
  install -d $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema/redhat
  install %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/openldap/schema/redhat/

  # Remove unpackaged files.
  rm -f $RPM_BUILD_ROOT/%{_datadir}/openldap/migration/*.{instdir,simple,schema,mktemp,suffix,noaliases}
  rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la
  rm -f $RPM_BUILD_ROOT/%{_sbindir}/openldap/*.a
  rm -f $RPM_BUILD_ROOT/%{_sbindir}/openldap/*.so
%if %{nss_ldap_build}
  rm -f $RPM_BUILD_ROOT/%{nss_ldap_libdir}/*.la
  rm -f $RPM_BUILD_ROOT/%{nss_ldap_libdir}/*.so*
%endif

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%pre servers
  # Take care to only do ownership-changing if we're adding the user.
  if /usr/sbin/useradd -c "LDAP User" -u 55 -s /bin/false -r -d /var/lib/ldap ldap 2> /dev/null ; then
    if [ -d /var/lib/ldap ] ; then
      for dbfile in /var/lib/ldap/* ; do
        if [ -f $dbfile ] ; then
          chown ldap:ldap $dbfile
        fi
      done
    fi
  fi

%post servers
  /sbin/ldconfig
  /sbin/chkconfig --add ldap

%preun servers
  if [ "$1" = "0" ] ; then
	/etc/init.dldap stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del ldap
  fi

%postun servers
  /sbin/ldconfig

  if [ $1 -ge 1 ] ; then
    /etc/init.d/ldap condrestart > /dev/null 2>&1 || :
  fi

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Jul 08 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.23, Release 2
  - Rebuild against openssl-0.9.8.

* Wed Jul 06 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.2.23, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
